<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph::Any Class Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="classes.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="classes.html"><span>Class&nbsp;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="namespace_sylph.html">Sylph</a>::<a class="el" href="class_sylph_1_1_any.html">Any</a>
  </div>
</div>
<div class="contents">
<h1>Sylph::Any Class Reference</h1><!-- doxytag: class="Sylph::Any" --><!-- doxytag: inherits="Sylph::Object" -->Wrapper class for any kind of class.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="_any_8h-source.html">Sylph/Core/Any.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Sylph::Any:</div>
<div class="dynsection">
<p><center><img src="class_sylph_1_1_any__inherit__graph.png" border="0" usemap="#_sylph_1_1_any__inherit__map" alt="Inheritance graph"></center>
<map name="_sylph_1_1_any__inherit__map">
<area shape="rect" id="node2" href="class_sylph_1_1_object.html" title="The root of all classes." alt="" coords="5,5,117,35"></map>
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="class_sylph_1_1_any-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#63cde8641e21cda8efe82b3752bed66f">Any</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new, empty <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object.  <a href="#63cde8641e21cda8efe82b3752bed66f"></a><br></td></tr>
<tr><td class="memTemplParams" nowrap colspan="2">template&lt;class T &gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#b03f14f5215fe956a8e76d6350024f02">Any</a> (const T &amp;value)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Creates a new <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object from an existing object.  <a href="#b03f14f5215fe956a8e76d6350024f02"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#ee814145fbd7b187170205dfb8b866d8">Any</a> (const <a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;other)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Copies this <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object from another <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object.  <a href="#ee814145fbd7b187170205dfb8b866d8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="f7ddbe1a5c8bd1633b055ca2094cd92e"></a><!-- doxytag: member="Sylph::Any::~Any" ref="f7ddbe1a5c8bd1633b055ca2094cd92e" args="()" -->
&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#f7ddbe1a5c8bd1633b055ca2094cd92e">~Any</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Default destructor. <br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#eb843e6be33616bd4559f68957799c25">empty</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Check if this <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> is pointing to something.  <a href="#eb843e6be33616bd4559f68957799c25"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const std::type_info &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#77fc0fdfa5c15a6366378f5f770e2e4d">type</a> () const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the typeinfo of the data pointed to.  <a href="#77fc0fdfa5c15a6366378f5f770e2e4d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#85164cb8a7df065867204ca565f18675">operator=</a> (const <a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;rhs)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assigns an other <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> instance to this one.  <a href="#85164cb8a7df065867204ca565f18675"></a><br></td></tr>
<tr><td class="memTemplParams" nowrap colspan="2">template&lt;class T &gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top"><a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#a7cc9001e0b52ac76a89451828a9ab4d">operator=</a> (T &amp;value)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assigns a new value to this <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a>.  <a href="#a7cc9001e0b52ac76a89451828a9ab4d"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Friends</h2></td></tr>
<tr><td class="memTemplParams" nowrap colspan="2">template&lt;class T &gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">T *&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="class_sylph_1_1_any.html#6b563e1a6ffb4f307f72d4b6543a3e85">any_cast</a> (<a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;any)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Cast an <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> to the type it is holding.  <a href="#6b563e1a6ffb4f307f72d4b6543a3e85"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
Wrapper class for any kind of class. 
<p>
<a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> allows you to wrap any kind of class in it, in other words, it acts as an universal supertype. It is similar to what <code>void*</code> was used in C, but safer to use (wrong casts return a null pointer instead of a corrupted pointer). <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> is useful for using in collections, it will allow any kind of object to be stored in a single collection. Other languages or toolkits use a superclass for this purpose, (e.g. <a class="el" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a>), but this does not take primitive or alien (i.e. from another API) types into account. <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> can be used safely for such purposes and is recommended over <code>void*</code> or <a class="el" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a>. <p>
An example of a predefined collection using <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> is Dictionary, which acts as a <a class="el" href="class_sylph_1_1_hash_map.html">HashMap</a> of <a class="el" href="class_sylph_1_1_string.html" title="The String class represents character strings.">String</a>,<a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a>. <hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="63cde8641e21cda8efe82b3752bed66f"></a><!-- doxytag: member="Sylph::Any::Any" ref="63cde8641e21cda8efe82b3752bed66f" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Sylph::Any::Any           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new, empty <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object. 
<p>
The internal pointer will be initialized to <code>null</code>. 
</div>
</div><p>
<a class="anchor" name="b03f14f5215fe956a8e76d6350024f02"></a><!-- doxytag: member="Sylph::Any::Any" ref="b03f14f5215fe956a8e76d6350024f02" args="(const T &amp;value)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">Sylph::Any::Any           </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&nbsp;</td>
          <td class="paramname"> <em>value</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Creates a new <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object from an existing object. 
<p>
The object will be copied, therefore it is advised you only use easy-to-copy data, such as primitives, reference counted data, or pointers.<p>
Note: <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> will <b>not</b> take ownership over pointers. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>value</em>&nbsp;</td><td>The value the new instance of <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> will point to. </td></tr>
  </table>
</dl>

</div>
</div><p>
<a class="anchor" name="ee814145fbd7b187170205dfb8b866d8"></a><!-- doxytag: member="Sylph::Any::Any" ref="ee814145fbd7b187170205dfb8b866d8" args="(const Any &amp;other)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Sylph::Any::Any           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>other</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Copies this <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object from another <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object. 
<p>
The internal pointer will be copied to this new <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> object. 
</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="eb843e6be33616bd4559f68957799c25"></a><!-- doxytag: member="Sylph::Any::empty" ref="eb843e6be33616bd4559f68957799c25" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Sylph::Any::empty           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Check if this <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> is pointing to something. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd><em>true</em> if the internal pointer is a <code>null</code> pointer, <em>false</em> otherwise. </dd></dl>

</div>
</div><p>
<a class="anchor" name="a7cc9001e0b52ac76a89451828a9ab4d"></a><!-- doxytag: member="Sylph::Any::operator=" ref="a7cc9001e0b52ac76a89451828a9ab4d" args="(T &amp;value)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_sylph_1_1_any.html">Any</a>&amp; Sylph::Any::operator=           </td>
          <td>(</td>
          <td class="paramtype">T &amp;&nbsp;</td>
          <td class="paramname"> <em>value</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Assigns a new value to this <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a>. 
<p>
Again, the value can be of any type, and is not restricted by the type that had been before in the <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a>. The internal data pointer gets completely replaced by a new one, pointing to the new data. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>value</em>&nbsp;</td><td>A new value for the <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> to point to. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The current any, with the updated data pointer. </dd></dl>

</div>
</div><p>
<a class="anchor" name="85164cb8a7df065867204ca565f18675"></a><!-- doxytag: member="Sylph::Any::operator=" ref="85164cb8a7df065867204ca565f18675" args="(const Any &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="class_sylph_1_1_any.html">Any</a>&amp; Sylph::Any::operator=           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>rhs</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Assigns an other <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> instance to this one. 
<p>
The assignment simply consists of copying the internal data pointer to this <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a>. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>rhs</em>&nbsp;</td><td>An other <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> instance to copy the data pointer from. </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>The current <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a>, modified to be equal to the other <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a>. </dd></dl>

</div>
</div><p>
<a class="anchor" name="77fc0fdfa5c15a6366378f5f770e2e4d"></a><!-- doxytag: member="Sylph::Any::type" ref="77fc0fdfa5c15a6366378f5f770e2e4d" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::type_info&amp; Sylph::Any::type           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td> const<code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the typeinfo of the data pointed to. 
<p>
The result returned is compatible with the return value of the <code>typeid</code> operator, which means that you can check if the <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> can be casted to a type using its <code>typeid</code>. E.g: <pre>
 if(myany.type() == typeid(int)) {
     // safe to cast to int here
 } else {
     // give some error message about the wrong type
 }
 </pre> If the internal data pointer is a <code>null</code> pointer, it will return the <code>typeid</code> of <code>void</code>. 
</div>
</div><p>
<hr><h2>Friends And Related Function Documentation</h2>
<a class="anchor" name="6b563e1a6ffb4f307f72d4b6543a3e85"></a><!-- doxytag: member="Sylph::Any::any_cast" ref="6b563e1a6ffb4f307f72d4b6543a3e85" args="(Any &amp;any)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T* any_cast           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="class_sylph_1_1_any.html">Any</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>any</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td><code> [friend]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Cast an <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> to the type it is holding. 
<p>
This cast is completely safe, and either returns a correct pointer, or completely fails. <dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>any</em>&nbsp;</td><td>An <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> to convert to an instance of the type it is representing </td></tr>
  </table>
</dl>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>A pointer to the internal data of the <a class="el" href="class_sylph_1_1_any.html" title="Wrapper class for any kind of class.">Any</a> if the conversion was successful, <code>null</code> otherwise. </dd></dl>

</div>
</div><p>
</div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
